## pgagroal 1.5.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.14.0)

set(VERSION_MAJOR "1")
set(VERSION_MINOR "5")
set(VERSION_PATCH "0")
set(VERSION_STRING ${VERSION_MAJOR}.${VERSION_MINOR}.${VERSION_PATCH})

#
# Avoid source tree pollution
#
set(CMAKE_DISABLE_SOURCE_CHANGES ON)
set(CMAKE_DISABLE_IN_SOURCE_BUILD ON)

If(CMAKE_SOURCE_DIR STREQUAL CMAKE_BINARY_DIR)
  message(FATAL_ERROR "In-source builds are not permitted. Make a separate folder for building:\nmkdir build; cd build; cmake ..\nBefore that, remove the files already created:\nrm -rf CMakeCache.txt CMakeFiles")
endif(CMAKE_SOURCE_DIR STREQUAL CMAKE_BINARY_DIR)

project(pgagroal VERSION ${VERSION_STRING} LANGUAGES  C)

set(CPACK_PACKAGE_VERSION_MAJOR ${VERSION_MAJOR})
set(CPACK_PACKAGE_VERSION_MINOR ${VERSION_MINOR})
set(CPACK_PACKAGE_VERSION_PATCH ${VERSION_PATCH})
set(CPACK_SOURCE_GENERATOR "TGZ")
set(CPACK_SOURCE_PACKAGE_FILE_NAME
  "${CMAKE_PROJECT_NAME}-${CPACK_PACKAGE_VERSION_MAJOR}.${CPACK_PACKAGE_VERSION_MINOR}.${CPACK_PACKAGE_VERSION_PATCH}")
set(CPACK_SOURCE_IGNORE_FILES
  "/build/;/.git/;/.github/;/*.patch;/.bundle/;/_site/;/vendor/;~$;${CPACK_SOURCE_IGNORE_FILES}")
include(CPack)

set(CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake" ${CMAKE_MODULE_PATH})
set(CMAKE_EXPORT_COMPILE_COMMANDS ON)

message(STATUS "pgagroal ${VERSION_STRING}")

include(CheckCCompilerFlag)
include(CheckCSourceCompiles)
include(FindPackageHandleStandardArgs)
include(GNUInstallDirs)

if (NOT CMAKE_BUILD_TYPE)
  set(CMAKE_BUILD_TYPE Release CACHE STRING "Choose the type of build, options are: Debug Release Performance" FORCE)
endif ()

message(STATUS "Build type is ${CMAKE_BUILD_TYPE}")
message(STATUS "System is ${CMAKE_SYSTEM_NAME}")

set(SUPPORTED_COMPILERS "GNU" "Clang" "AppleClang")

# Check for a supported compiler
if (NOT CMAKE_C_COMPILER_ID IN_LIST SUPPORTED_COMPILERS)
   message(FATAL_ERROR "Unsupported compiler ${CMAKE_C_COMPILER_ID}. Supported compilers are: ${SUPPORTED_COMPILERS}")
endif ()

CHECK_C_COMPILER_FLAG("-std=c17" COMPILER_SUPPORTS_C17)
if(NOT COMPILER_SUPPORTS_C17)
  message(FATAL_ERROR "The compiler ${CMAKE_C_COMPILER} has no C17 support. Please use a different C compiler.")
endif()

find_package(Libev 4.11)
if (LIBEV_FOUND)
  message(STATUS "libev found")
else ()
  message(FATAL_ERROR "libev needed")
endif()

find_package(OpenSSL)
if (OPENSSL_FOUND)
  message(STATUS "OpenSSL found")
else ()
  message(FATAL_ERROR "OpenSSL needed")
endif()

find_package(Rst2man)
if (RST2MAN_FOUND)
  message(STATUS "rst2man found")
else ()
  message(FATAL_ERROR "rst2man needed")
endif()

if (${CMAKE_SYSTEM_NAME} STREQUAL "Linux")
  find_package(Systemd)
  if (SYSTEMD_FOUND)
    message(STATUS "systemd found")
  else ()
    message(FATAL_ERROR "systemd needed")
  endif()
endif()

file(MAKE_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}/src/")

add_subdirectory(doc)
add_subdirectory(src)

=== src/CMakeLists.txt ===
#
# Add files for libpgagroal
#
FILE(GLOB SOURCE_FILES "libpgagroal/*.c")
FILE(GLOB HEADER_FILES "include/*.h")

set(SOURCES ${SOURCE_FILES} ${HEADER_FILES})

#
# OS
#
if (${CMAKE_SYSTEM_NAME} STREQUAL "Linux")

  add_compile_options(-DHAVE_LINUX)
  add_compile_options(-D_POSIX_C_SOURCE=200809L)

  #
  # Include directories
  #
  include_directories(
    ${CMAKE_CURRENT_SOURCE_DIR}/include
    ${LIBEV_INCLUDE_DIRS}
    ${OPENSSL_INCLUDE_DIR}
    ${SYSTEMD_INCLUDE_DIRS}
  )

  #
  # Library directories
  #
  link_libraries(
    ${LIBEV_LIBRARIES}
    ${OPENSSL_CRYPTO_LIBRARY}
    ${OPENSSL_SSL_LIBRARY}
    ${SYSTEMD_LIBRARIES}
  )

  set(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -Wl,--no-undefined")

else()

  add_compile_options(-D_XOPEN_SOURCE=700)
  add_compile_options(-D_BSD_SOURCE)
  add_compile_options(-D_DEFAULT_SOURCE)
  add_compile_options(-D__BSD_VISIBLE)

  if (${CMAKE_SYSTEM_NAME} STREQUAL "OpenBSD")
    add_compile_options(-DHAVE_OPENBSD)
  elseif (${CMAKE_SYSTEM_NAME} STREQUAL "FreeBSD")
     add_compile_options(-DHAVE_FREEBSD)
  endif()

  #
  # Include directories
  #
  include_directories(
    ${CMAKE_CURRENT_SOURCE_DIR}/include
    ${LIBEV_INCLUDE_DIRS}
    ${OPENSSL_INCLUDE_DIRS}
  )

  #
  # Library directories
  #
  link_libraries(
    ${LIBEV_LIBRARIES}
    ${OPENSSL_LIBRARIES}
  )
endif()

#
# Compile options
#
add_compile_options(-g)
add_compile_options(-Wall)
add_compile_options(-std=c17)
add_compile_options(-D__USE_ISOC11)
add_compile_options(-D_GNU_SOURCE)
add_compile_options(-Wno-deprecated)
add_compile_options(-Wno-deprecated-declarations)

#
# version number and string management
#
add_compile_options(-DPGAGROAL_MAJOR_VERSION=${VERSION_MAJOR})
add_compile_options(-DPGAGROAL_MINOR_VERSION=${VERSION_MINOR})
add_compile_options(-DPGAGROAL_PATCH_VERSION=${VERSION_PATCH})
add_compile_options(-DPGAGROAL_VERSION="${VERSION_STRING}")

if(CMAKE_C_COMPILER_ID STREQUAL "GNU")
  add_compile_options(-Wstrict-prototypes)
endif()

check_c_compiler_flag(-fPIC HAS_PIC)
if (HAS_PIC)
  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -fPIC")
endif()

if (${CMAKE_SYSTEM_NAME} STREQUAL "Linux")
  include(CheckPIESupported)
  check_pie_supported()
endif()

if (CMAKE_BUILD_TYPE MATCHES Debug)
  add_compile_options(-O0)
  add_compile_options(-DDEBUG)

  check_c_compiler_flag(-Wformat HAS_FORMAT)
  if (HAS_FORMAT)
    set(CMAKE_C_FLAGS_DEBUG "${CMAKE_C_FLAGS_DEBUG} -Wformat")
  endif()

  check_c_compiler_flag(-Wformat-security HAS_FORMAT_SECURITY)
  if (HAS_FORMAT_SECURITY)
    set(CMAKE_C_FLAGS_DEBUG "${CMAKE_C_FLAGS_DEBUG} -Wformat-security")
  endif()

  check_c_compiler_flag(-fstack-protector-strong HAS_STACK_PROTECTOR_STRONG)
  if (HAS_STACK_PROTECTOR_STRONG)
    set(CMAKE_C_FLAGS_DEBUG "${CMAKE_C_FLAGS_DEBUG} -fstack-protector-strong")
  endif()

  check_c_compiler_flag(-rdynamic HAS_DYNAMIC)
  if (HAS_DYNAMIC)
    set (CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -rdynamic")
    set (CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -rdynamic")
  endif()

  check_c_compiler_flag(-fstack-protector-strong HAS_STACKPROTECTOR_STRONG)
  if (HAS_STACKPROTECTOR_STRONG)
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -fstack-protector-strong")
  else()
    check_c_compiler_flag(-fstack-protector HAS_STACKPROTECTOR)
    if (HAS_STACKPROTECTOR)
      set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -fstack-protector")
    endif()
  endif()

  check_c_compiler_flag(-Wl,-z,relro HAS_RELRO)
  if (HAS_RELRO)
    set (CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -Wl,-z,relro")
    set (CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -Wl,-z,relro")
  endif()

  check_c_compiler_flag(-Wl,-z,now HAS_NOW)
  if (HAS_NOW)
    set (CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -Wl,-z,now")
    set (CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -Wl,-z,now")
  endif()

  if(CMAKE_C_COMPILER_ID STREQUAL "Clang")
    if (NOT ${CMAKE_SYSTEM_NAME} STREQUAL "OpenBSD")
      add_compile_options(-fsanitize=address)

      set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_LINKER_FLAGS_DEBUG} -fsanitize=address")
      set(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS_DEBUG} -fsanitize=address")
    endif()
  endif()

  check_c_compiler_flag(-fno-omit-frame-pointer HAS_NO_OMIT_FRAME_POINTER)
  if (HAS_NO_OMIT_FRAME_POINTER)
    set(CMAKE_C_FLAGS_DEBUG "${CMAKE_C_FLAGS_DEBUG} -fno-omit-frame-pointer")
  endif()
endif()

if (CMAKE_BUILD_TYPE MATCHES Release OR CMAKE_BUILD_TYPE MATCHES RelWithDebInfo)
  add_compile_options(-O2)
  add_compile_options(-DNDEBUG)

  check_c_compiler_flag(-Wformat HAS_FORMAT)
  if (HAS_FORMAT)
    set(CMAKE_C_FLAGS_DEBUG "${CMAKE_C_FLAGS_DEBUG} -Wformat")
  endif()

  check_c_compiler_flag(-Wformat-security HAS_FORMAT_SECURITY)
  if (HAS_FORMAT_SECURITY)
    set(CMAKE_C_FLAGS_DEBUG "${CMAKE_C_FLAGS_DEBUG} -Wformat-security")
  endif()

  check_c_compiler_flag(-fstack-protector-strong HAS_STACK_PROTECTOR_STRONG)
  if (HAS_STACK_PROTECTOR_STRONG)
    set(CMAKE_C_FLAGS_DEBUG "${CMAKE_C_FLAGS_DEBUG} -fstack-protector-strong")
  endif()

  check_c_compiler_flag(-rdynamic HAS_DYNAMIC)
  if (HAS_DYNAMIC)
    set (CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -rdynamic")
    set (CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -rdynamic")
  endif()

  check_c_compiler_flag(-fstack-protector-strong HAS_STACKPROTECTOR_STRONG)
  if (HAS_STACKPROTECTOR_STRONG)
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -fstack-protector-strong")
  else()
    check_c_compiler_flag(-fstack-protector HAS_STACKPROTECTOR)
    if (HAS_STACKPROTECTOR)
      set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -fstack-protector")
    endif()
  endif()

  check_c_compiler_flag(-Wl,-z,relro HAS_RELRO)
  if (HAS_RELRO)
    set (CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -Wl,-z,relro")
    set (CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -Wl,-z,relro")
  endif()

  check_c_compiler_flag(-Wl,-z,now HAS_NOW)
  if (HAS_NOW)
    set (CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -Wl,-z,now")
    set (CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -Wl,-z,now")
  endif()
endif (CMAKE_BUILD_TYPE MATCHES Release OR CMAKE_BUILD_TYPE MATCHES RelWithDebInfo)

if (CMAKE_BUILD_TYPE MATCHES Performance)
  add_compile_options(-O2)
  add_compile_options(-DNDEBUG)

  if(CMAKE_C_COMPILER_ID STREQUAL "GNU")
    add_compile_options(-march=native)
    add_compile_options(-mtune=native)
    add_compile_options(-flto)
  endif()
endif (CMAKE_BUILD_TYPE MATCHES Performance)

#
# Build libpgagroal
#
add_library(pgagroal SHARED ${SOURCES})
set_target_properties(pgagroal PROPERTIES LINKER_LANGUAGE C VERSION ${VERSION_STRING}
                               SOVERSION ${VERSION_MAJOR})
target_link_libraries(pgagroal PUBLIC)

install(TARGETS pgagroal DESTINATION ${CMAKE_INSTALL_LIBDIR}/)

#
# Build pgagroal
#
add_executable(pgagroal-bin main.c ${RESOURCE_OBJECT})
if (CMAKE_C_LINK_PIE_SUPPORTED)
  set_target_properties(pgagroal-bin PROPERTIES LINKER_LANGUAGE C POSITION_INDEPENDENT_CODE TRUE OUTPUT_NAME pgagroal)
else()
  set_target_properties(pgagroal-bin PROPERTIES LINKER_LANGUAGE C POSITION_INDEPENDENT_CODE FALSE OUTPUT_NAME pgagroal)
endif()
target_link_libraries(pgagroal-bin pgagroal)

install(TARGETS pgagroal-bin DESTINATION ${CMAKE_INSTALL_BINDIR})

#
# Build pgagroal-cli
#
add_executable(pgagroal-cli-bin cli.c ${RESOURCE_OBJECT})
if (CMAKE_C_LINK_PIE_SUPPORTED)
  set_target_properties(pgagroal-cli-bin PROPERTIES LINKER_LANGUAGE C POSITION_INDEPENDENT_CODE TRUE OUTPUT_NAME pgagroal-cli)
else()
  set_target_properties(pgagroal-cli-bin PROPERTIES LINKER_LANGUAGE C POSITION_INDEPENDENT_CODE FALSE OUTPUT_NAME pgagroal-cli)
endif()
target_link_libraries(pgagroal-cli-bin pgagroal)

install(TARGETS pgagroal-cli-bin DESTINATION ${CMAKE_INSTALL_BINDIR})

#
# Build pgagroal-admin
#
add_executable(pgagroal-admin-bin admin.c ${RESOURCE_OBJECT})
if (CMAKE_C_LINK_PIE_SUPPORTED)
  set_target_properties(pgagroal-admin-bin PROPERTIES LINKER_LANGUAGE C POSITION_INDEPENDENT_CODE TRUE OUTPUT_NAME pgagroal-admin)
else()
  set_target_properties(pgagroal-admin-bin PROPERTIES LINKER_LANGUAGE C POSITION_INDEPENDENT_CODE FALSE OUTPUT_NAME pgagroal-admin)
endif()
target_link_libraries(pgagroal-admin-bin pgagroal)

install(TARGETS pgagroal-admin-bin DESTINATION ${CMAKE_INSTALL_BINDIR})

=== debian/changelog ===
pgagroal (1.5.0-2) unstable; urgency=medium

  * Add -latomic for armel/mipsel/powerpc/riscv64.

 -- Christoph Berg <myon@debian.org>  Thu, 24 Nov 2022 10:38:58 +0100

pgagroal (1.5.0-1) unstable; urgency=medium

  * Initial release.

 -- Christoph Berg <myon@debian.org>  Wed, 23 Nov 2022 16:34:19 +0100

=== debian/control ===
Source: pgagroal
Section: database
Priority: optional
Maintainer: Debian PostgreSQL Maintainers <team+postgresql@tracker.debian.org>
Uploaders:
 Christoph Berg <myon@debian.org>,
Build-Depends:
 cmake (>= 3.14.0),
 debhelper-compat (= 13),
 libev-dev,
 libssl-dev,
 libsystemd-dev,
 postgresql-all,
 python3-docutils,
Standards-Version: 4.6.1
Rules-Requires-Root: no
Homepage: https://github.com/agroal/pgagroal
Vcs-Browser: https://salsa.debian.org/postgresql/pgagroal
Vcs-Git: https://salsa.debian.org/postgresql/pgagroal.git

Package: pgagroal
Architecture: any
Depends:
 postgresql-common,
 ${misc:Depends},
 ${shlibs:Depends},
Description: High-performance connection pool for PostgreSQL
 pgagroal is a high-performance protocol-native connection pool for PostgreSQL.
 .
 Pronounced: p-g-a-gro-al, named after Agroal in Portugal.
 .
 Features:
  * High performance
  * Connection pool
  * Limit connections for users and databases
  * Prefill support
  * Remove idle connections
  * Perform connection validation
  * Enable / disable database access
  * Graceful / fast shutdown
  * Prometheus support
  * Grafana 8 dashboard
  * Remote management
  * Authentication query support
  * Failover support
  * Transport Layer Security (TLS) v1.2+ support
  * Daemon mode
  * User vault

=== debian/rules ===
#!/usr/bin/make -f

override_dh_auto_configure:
	dh_auto_configure -- -DCMAKE_SKIP_BUILD_RPATH=TRUE

override_dh_installsystemd:
	# only enable the socket, not the service
	dh_installsystemd pgagroal.socket

%:
	dh $@ --buildsystem cmake

## pgagroal 1.5.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -2,7 +2,7 @@
 
 set(VERSION_MAJOR "1")
 set(VERSION_MINOR "5")
-set(VERSION_PATCH "0")
+set(VERSION_PATCH "1")
 set(VERSION_STRING ${VERSION_MAJOR}.${VERSION_MINOR}.${VERSION_PATCH})
 
 #
@@ -78,6 +78,13 @@
 endif()
 
 if (${CMAKE_SYSTEM_NAME} STREQUAL "Linux")
+  find_package(Libatomic)
+  if (LIBATOMIC_FOUND)
+    message(STATUS "libatomic found")
+  else ()
+    message(FATAL_ERROR "libatomic needed")
+  endif()
+
   find_package(Systemd)
   if (SYSTEMD_FOUND)
     message(STATUS "systemd found")

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -32,6 +32,7 @@
     ${OPENSSL_CRYPTO_LIBRARY}
     ${OPENSSL_SSL_LIBRARY}
     ${SYSTEMD_LIBRARIES}
+    ${LIBATOMIC_LIBRARY}
   )
 
   set(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -Wl,--no-undefined")

=== debian/changelog ===
pgagroal (1.5.1-3.pgdg20.04+1) focal-pgdg; urgency=medium

  * Rebuild for focal-pgdg.
  * Changes applied by generate-pgdg-source:
    + Using debhelper 12.

 -- PostgreSQL on Debian and Ubuntu <pgsql-pkg-debian@lists.postgresql.org>  Thu, 23 Nov 2023 16:45:54 +0000

pgagroal (1.5.1-3) unstable; urgency=medium

  * Install systemd units using dh_installsystemd.

 -- Christoph Berg <myon@debian.org>  Thu, 23 Nov 2023 16:45:54 +0000

pgagroal (1.5.1-2) unstable; urgency=medium

  * Fix PG protocol on big-endian machines. (Closes: #1031011)
  * Use larger buffer for protocol messages.

 -- Christoph Berg <myon@debian.org>  Wed, 06 Sep 2023 15:27:20 +0000

pgagroal (1.5.1-1) unstable; urgency=medium

  * New upstream version.

 -- Christoph Berg <myon@debian.org>  Sat, 13 May 2023 09:45:13 +0200

=== debian/control ===
--- 
+++ 
@@ -6,7 +6,7 @@
  Christoph Berg <myon@debian.org>,
 Build-Depends:
  cmake (>= 3.14.0),
- debhelper-compat (= 13),
+ debhelper (>= 12),
  libev-dev,
  libssl-dev,
  libsystemd-dev,

## pgagroal 1.6.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,8 +1,8 @@
 cmake_minimum_required(VERSION 3.14.0)
 
 set(VERSION_MAJOR "1")
-set(VERSION_MINOR "5")
-set(VERSION_PATCH "1")
+set(VERSION_MINOR "6")
+set(VERSION_PATCH "0")
 set(VERSION_STRING ${VERSION_MAJOR}.${VERSION_MINOR}.${VERSION_PATCH})
 
 #
@@ -34,6 +34,7 @@
 
 include(CheckCCompilerFlag)
 include(CheckCSourceCompiles)
+include(CheckLinkerFlag)
 include(FindPackageHandleStandardArgs)
 include(GNUInstallDirs)
 
@@ -77,6 +78,16 @@
   message(FATAL_ERROR "rst2man needed")
 endif()
 
+# search for cJSON library
+# <https://github.com/DaveGamble/cJSON>
+find_package(cJSON)
+if (cJSON_FOUND)
+  message(STATUS "cJSON found version ${CJSON_VERSION}")
+else ()
+  message(FATAL_ERROR "cJSON needed")
+endif()
+
+
 if (${CMAKE_SYSTEM_NAME} STREQUAL "Linux")
   find_package(Libatomic)
   if (LIBATOMIC_FOUND)

=== doc/CMakeLists.txt ===
# man target
add_custom_target(man ALL)

# man page definitions
set(PGAGROAL_SRC_FILE "${CMAKE_CURRENT_SOURCE_DIR}/man/pgagroal.1.rst")
set(PGAGROAL_DST_FILE "${CMAKE_CURRENT_BINARY_DIR}/pgagroal.1")
set(PGAGROAL_CLI_SRC_FILE "${CMAKE_CURRENT_SOURCE_DIR}/man/pgagroal-cli.1.rst")
set(PGAGROAL_CLI_DST_FILE "${CMAKE_CURRENT_BINARY_DIR}/pgagroal-cli.1")
set(PGAGROAL_ADMIN_SRC_FILE "${CMAKE_CURRENT_SOURCE_DIR}/man/pgagroal-admin.1.rst")
set(PGAGROAL_ADMIN_DST_FILE "${CMAKE_CURRENT_BINARY_DIR}/pgagroal-admin.1")
set(PGAGROAL_CONF_SRC_FILE "${CMAKE_CURRENT_SOURCE_DIR}/man/pgagroal.conf.5.rst")
set(PGAGROAL_CONF_DST_FILE "${CMAKE_CURRENT_BINARY_DIR}/pgagroal.conf.5")
set(PGAGROAL_HBA_CONF_SRC_FILE "${CMAKE_CURRENT_SOURCE_DIR}/man/pgagroal_hba.conf.5.rst")
set(PGAGROAL_HBA_CONF_DST_FILE "${CMAKE_CURRENT_BINARY_DIR}/pgagroal_hba.conf.5")
set(PGAGROAL_DATABASES_CONF_SRC_FILE "${CMAKE_CURRENT_SOURCE_DIR}/man/pgagroal_databases.conf.5.rst")
set(PGAGROAL_DATABASES_CONF_DST_FILE "${CMAKE_CURRENT_BINARY_DIR}/pgagroal_databases.conf.5")

# pgagroal.1
add_custom_command(
  TARGET man
  COMMAND ${RST2MAN_EXECUTABLE} ${PGAGROAL_SRC_FILE} ${PGAGROAL_DST_FILE}
  OUTPUTS ${PGAGROAL_DST_FILE}
)

# pgagroal-cli.1
add_custom_command(
  TARGET man
  COMMAND ${RST2MAN_EXECUTABLE} ${PGAGROAL_CLI_SRC_FILE} ${PGAGROAL_CLI_DST_FILE}
  OUTPUTS ${PGAGROAL_CLI_DST_FILE}
)

# pgagroal-admin.1
add_custom_command(
  TARGET man
  COMMAND ${RST2MAN_EXECUTABLE} ${PGAGROAL_ADMIN_SRC_FILE} ${PGAGROAL_ADMIN_DST_FILE}
  OUTPUTS ${PGAGROAL_ADMIN_DST_FILE}
)

# pgagroal.conf.5
add_custom_command(
  TARGET man
  COMMAND ${RST2MAN_EXECUTABLE} ${PGAGROAL_CONF_SRC_FILE} ${PGAGROAL_CONF_DST_FILE}
  OUTPUTS ${PGAGROAL_CONF_DST_FILE}
)

# pgagroal_hba.conf.5
add_custom_command(
  TARGET man
  COMMAND ${RST2MAN_EXECUTABLE} ${PGAGROAL_HBA_CONF_SRC_FILE} ${PGAGROAL_HBA_CONF_DST_FILE}
  OUTPUTS ${PGAGROAL_HBA_CONF_DST_FILE}
)

# pgagroal_databases.conf.5
add_custom_command(
  TARGET man
  COMMAND ${RST2MAN_EXECUTABLE} ${PGAGROAL_DATABASES_CONF_SRC_FILE} ${PGAGROAL_DATABASES_CONF_DST_FILE}
  OUTPUTS ${PGAGROAL_DATABASES_CONF_DST_FILE}
)

# man pages
add_custom_command(
  TARGET man
  DEPENDS ${PGAGROAL_DST_FILE} ${PGAGROAL_CLI_DST_FILE} ${PGAGROAL_ADMIN_DST_FILE} ${PGAGROAL_CONF_DST_FILE} ${PGAGROAL_HBA_CONF_DST_FILE} ${PGAGROAL_DATABASES_CONF_DST_FILE}
)

#
# Install configuration and documentation
#
install(FILES etc/pgagroal.conf DESTINATION share/doc/pgagroal/etc)
install(FILES etc/pgagroal_hba.conf DESTINATION share/doc/pgagroal/etc)

install(DIRECTORY . DESTINATION share/doc/pgagroal FILES_MATCHING PATTERN "*.md" PATTERN "etc" EXCLUDE PATTERN "images" EXCLUDE PATTERN "man" EXCLUDE)
install(DIRECTORY images/ DESTINATION share/doc/pgagroal/images FILES_MATCHING PATTERN "*.png")

install(FILES ${PGAGROAL_DST_FILE} DESTINATION share/man/man1)
install(FILES ${PGAGROAL_CLI_DST_FILE} DESTINATION share/man/man1)
install(FILES ${PGAGROAL_ADMIN_DST_FILE} DESTINATION share/man/man1)
install(FILES ${PGAGROAL_CONF_DST_FILE} DESTINATION share/man/man5)
install(FILES ${PGAGROAL_HBA_CONF_DST_FILE} DESTINATION share/man/man5)
install(FILES ${PGAGROAL_DATABASES_CONF_DST_FILE} DESTINATION share/man/man5)

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -22,6 +22,7 @@
     ${LIBEV_INCLUDE_DIRS}
     ${OPENSSL_INCLUDE_DIR}
     ${SYSTEMD_INCLUDE_DIRS}
+    ${CJSON_INCLUDE_DIRS}
   )
 
   #
@@ -33,10 +34,54 @@
     ${OPENSSL_SSL_LIBRARY}
     ${SYSTEMD_LIBRARIES}
     ${LIBATOMIC_LIBRARY}
+    ${CJSON_LIBRARIES}
   )
 
   set(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -Wl,--no-undefined")
-
+elseif(${CMAKE_SYSTEM_NAME} STREQUAL "Darwin")
+  find_program(HOMEBREW_EXECUTABLE brew)
+  if(EXISTS ${HOMEBREW_EXECUTABLE})
+    execute_process(
+      COMMAND ${HOMEBREW_EXECUTABLE} --prefix
+      OUTPUT_VARIABLE HOMEBREW_PREFIX
+      OUTPUT_STRIP_TRAILING_WHITESPACE)
+    message(STATUS "Homebrew found at ${HOMEBREW_PREFIX}")
+  endif()
+
+  #
+  # Detecting OpenSSL
+  #
+  execute_process(
+    COMMAND ${HOMEBREW_EXECUTABLE} --prefix openssl
+    OUTPUT_VARIABLE HOMEBREW_OPENSSL
+    OUTPUT_STRIP_TRAILING_WHITESPACE)
+  if(DEFINED HOMEBREW_OPENSSL)
+    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -I${HOMEBREW_OPENSSL}/include")
+  else()
+    message(FATAL_ERROR "Homebrew's OpenSSL needed")
+  endif()
+
+  add_compile_options(-D_DARWIN_C_SOURCE)
+  add_compile_options(-DHAVE_OSX)
+
+  #
+  # Include directories
+  #
+  include_directories(
+    ${CMAKE_CURRENT_SOURCE_DIR}/include
+    ${LIBEV_INCLUDE_DIRS}
+    ${OPENSSL_INCLUDE_DIRS}
+    ${CJSON_INCLUDE_DIRS}
+  )
+
+  #
+  # Library directories
+  #
+  link_libraries(
+    ${LIBEV_LIBRARIES}
+    ${OPENSSL_LIBRARIES}
+    ${CJSON_LIBRARIES}
+  )
 else()
 
   add_compile_options(-D_XOPEN_SOURCE=700)
@@ -57,6 +102,7 @@
     ${CMAKE_CURRENT_SOURCE_DIR}/include
     ${LIBEV_INCLUDE_DIRS}
     ${OPENSSL_INCLUDE_DIRS}
+    ${CJSON_INCLUDE_DIRS}
   )
 
   #
@@ -65,6 +111,7 @@
   link_libraries(
     ${LIBEV_LIBRARIES}
     ${OPENSSL_LIBRARIES}
+    ${CJSON_LIBRARIES}
   )
 endif()
 
@@ -73,6 +120,7 @@
 #
 add_compile_options(-g)
 add_compile_options(-Wall)
+add_compile_options(-Werror)
 add_compile_options(-std=c17)
 add_compile_options(-D__USE_ISOC11)
 add_compile_options(-D_GNU_SOURCE)
@@ -136,14 +184,15 @@
     endif()
   endif()
 
-  check_c_compiler_flag(-Wl,-z,relro HAS_RELRO)
-  if (HAS_RELRO)
+  check_c_compiler_flag(-Wl,arg HAS_LINKER)
+  check_linker_flag(C "-z relro" LINKER_HAS_RELRO)
+  if (HAS_LINKER AND LINKER_HAS_RELRO)
     set (CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -Wl,-z,relro")
     set (CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -Wl,-z,relro")
   endif()
 
-  check_c_compiler_flag(-Wl,-z,now HAS_NOW)
-  if (HAS_NOW)
+  check_linker_flag(C "-z now" LINKER_HAS_NOW)
+  if (HAS_LINKER AND LINKER_HAS_NOW)
     set (CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -Wl,-z,now")
     set (CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -Wl,-z,now")
   endif()
@@ -198,14 +247,15 @@
     endif()
   endif()
 
-  check_c_compiler_flag(-Wl,-z,relro HAS_RELRO)
-  if (HAS_RELRO)
+  check_c_compiler_flag(-Wl,arg HAS_LINKER)
+  check_linker_flag(C "-z relro" LINKER_HAS_RELRO)
+  if (HAS_LINKER AND HAS_RELRO)
     set (CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -Wl,-z,relro")
     set (CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -Wl,-z,relro")
   endif()
 
-  check_c_compiler_flag(-Wl,-z,now HAS_NOW)
-  if (HAS_NOW)
+  check_linker_flag(C "-z now" LINKER_HAS_NOW)
+  if (HAS_LINKER AND LINKER_HAS_NOW)
     set (CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -Wl,-z,now")
     set (CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -Wl,-z,now")
   endif()
@@ -270,3 +320,4 @@
 target_link_libraries(pgagroal-admin-bin pgagroal)
 
 install(TARGETS pgagroal-admin-bin DESTINATION ${CMAKE_INSTALL_BINDIR})
+

=== debian/changelog ===
pgagroal (1.6.0-1) unstable; urgency=medium

  * New upstream version 1.6.0.

 -- Christoph Berg <myon@debian.org>  Fri, 23 Feb 2024 15:38:54 +0100

=== debian/control ===
--- 
+++ 
@@ -6,7 +6,8 @@
  Christoph Berg <myon@debian.org>,
 Build-Depends:
  cmake (>= 3.14.0),
- debhelper (>= 12),
+ debhelper-compat (= 13),
+ libcjson-dev,
  libev-dev,
  libssl-dev,
  libsystemd-dev,

=== debian/tests/control ===
Depends:
 postgresql,
 procps,
 @,
Tests: connect
Restrictions: allow-stderr, needs-root

=== debian/watch ===
version=4
https://github.com/agroal/pgagroal/tags .*/(.*).tar.gz

## pgagroal 2.0.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,7 +1,7 @@
 cmake_minimum_required(VERSION 3.14.0)
 
-set(VERSION_MAJOR "1")
-set(VERSION_MINOR "6")
+set(VERSION_MAJOR "2")
+set(VERSION_MINOR "0")
 set(VERSION_PATCH "0")
 set(VERSION_STRING ${VERSION_MAJOR}.${VERSION_MINOR}.${VERSION_PATCH})
 
@@ -16,6 +16,12 @@
 endif(CMAKE_SOURCE_DIR STREQUAL CMAKE_BINARY_DIR)
 
 project(pgagroal VERSION ${VERSION_STRING} LANGUAGES  C)
+
+if (NOT DEFINED DOCS)
+  set(DOCS TRUE)
+endif()
+include(CTest)
+enable_testing()
 
 set(CPACK_PACKAGE_VERSION_MAJOR ${VERSION_MAJOR})
 set(CPACK_PACKAGE_VERSION_MINOR ${VERSION_MINOR})
@@ -24,7 +30,8 @@
 set(CPACK_SOURCE_PACKAGE_FILE_NAME
   "${CMAKE_PROJECT_NAME}-${CPACK_PACKAGE_VERSION_MAJOR}.${CPACK_PACKAGE_VERSION_MINOR}.${CPACK_PACKAGE_VERSION_PATCH}")
 set(CPACK_SOURCE_IGNORE_FILES
-  "/build/;/.git/;/.github/;/*.patch;/.bundle/;/_site/;/vendor/;~$;${CPACK_SOURCE_IGNORE_FILES}")
+  "/build/;/test/;/.cache/;/.git/;/.github/;/*.patch;/.bundle/;/_site/;/vendor/;~$;${CPACK_SOURCE_IGNORE_FILES}")
+set(CPACK_PACKAGE_CHECKSUM "SHA256")
 include(CPack)
 
 set(CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake" ${CMAKE_MODULE_PATH})
@@ -32,9 +39,14 @@
 
 message(STATUS "pgagroal ${VERSION_STRING}")
 
+set(check TRUE)
+set(container FALSE)
+
 include(CheckCCompilerFlag)
 include(CheckCSourceCompiles)
+include(CheckIncludeFile)
 include(CheckLinkerFlag)
+include(CheckFunctionExists)
 include(FindPackageHandleStandardArgs)
 include(GNUInstallDirs)
 
@@ -49,7 +61,7 @@
 
 # Check for a supported compiler
 if (NOT CMAKE_C_COMPILER_ID IN_LIST SUPPORTED_COMPILERS)
-   message(FATAL_ERROR "Unsupported compiler ${CMAKE_C_COMPILER_ID}. Supported compilers are: ${SUPPORTED_COMPILERS}")
+  message(FATAL_ERROR "Unsupported compiler ${CMAKE_C_COMPILER_ID}. Supported compilers are: ${SUPPORTED_COMPILERS}")
 endif ()
 
 CHECK_C_COMPILER_FLAG("-std=c17" COMPILER_SUPPORTS_C17)
@@ -57,11 +69,54 @@
   message(FATAL_ERROR "The compiler ${CMAKE_C_COMPILER} has no C17 support. Please use a different C compiler.")
 endif()
 
-find_package(Libev 4.11)
-if (LIBEV_FOUND)
-  message(STATUS "libev found")
-else ()
-  message(FATAL_ERROR "libev needed")
+find_package(Check)
+if (CHECK_FOUND)
+  message(STATUS "check found")
+  add_library(Check::check SHARED IMPORTED)
+  set_target_properties(Check::check PROPERTIES
+    IMPORTED_LOCATION ${CHECK_LIBRARY}
+    INTERFACE_INCLUDE_DIRECTORIES ${CHECK_INCLUDE_DIR})
+else ()
+  message(STATUS "check needed. The testsuite process will be skipped.")
+  set(check FALSE)
+endif()
+
+find_program(DOCKER_EXECUTABLE docker)
+find_program(PODMAN_EXECUTABLE podman)
+if (DOCKER_EXECUTABLE OR PODMAN_EXECUTABLE)
+  set(container TRUE)
+  message(STATUS "Docker or podman found")
+else ()
+  message(STATUS "Docker or podman needed. The test suite will be skipped.")
+endif()
+
+
+find_package(ZLIB)
+if (ZLIB_FOUND)
+  message(STATUS "zlib found")
+else ()
+  message(FATAL_ERROR "zlib needed")
+endif()
+
+find_package(BZip2)
+if (BZIP2_FOUND)
+  message(STATUS "bzip2 found")
+else ()
+  message(FATAL_ERROR "bzip2 needed")
+endif()
+
+find_package(Zstd)
+if (ZSTD_FOUND)
+  message(STATUS "zstd found")
+else ()
+  message(FATAL_ERROR "zstd needed")
+endif()
+
+find_package(Lz4)
+if (LZ4_FOUND)
+  message(STATUS "lz4 found")
+else ()
+  message(FATAL_ERROR "lz4 needed")
 endif()
 
 find_package(OpenSSL)
@@ -78,15 +133,36 @@
   message(FATAL_ERROR "rst2man needed")
 endif()
 
-# search for cJSON library
-# <https://github.com/DaveGamble/cJSON>
-find_package(cJSON)
-if (cJSON_FOUND)
-  message(STATUS "cJSON found version ${CJSON_VERSION}")
-else ()
-  message(FATAL_ERROR "cJSON needed")
-endif()
-
+find_package(THREAD)
+if (THREAD_FOUND)
+  message(STATUS "pthread found")
+else ()
+  message(FATAL_ERROR "pthread needed")
+endif()
+
+if (DOCS)
+  find_package(Pandoc)
+  if (PANDOC_FOUND)
+    message(STATUS "pandoc found")
+  else ()
+    set(DOCS FALSE)
+    message(STATUS "pandoc needed. The documentation will be skipped.")
+  endif()
+
+  find_package(Pdflatex)
+  if (PDFLATEX_FOUND)
+    message(STATUS "pdflatex found")
+  else ()
+    set(DOCS FALSE)
+    message(STATUS "pdflatex needed. The documentation will be skipped.")
+  endif()
+endif()
+
+find_package(Doxygen)
+
+if (DOXYGEN_FOUND)
+  message(status "Doxygen found: ${DOXYGEN_EXECUTABLE}")
+endif()
 
 if (${CMAKE_SYSTEM_NAME} STREQUAL "Linux")
   find_package(Libatomic)
@@ -96,15 +172,29 @@
     message(FATAL_ERROR "libatomic needed")
   endif()
 
+  find_package(Liburing 2.5)
+  if (LIBURING_FOUND)
+    message(STATUS "liburing found")
+  else()
+    message(FATAL_ERROR "liburing needed")
+  endif()
+
   find_package(Systemd)
   if (SYSTEMD_FOUND)
     message(STATUS "systemd found")
   else ()
-    message(FATAL_ERROR "systemd needed")
-  endif()
+  message(STATUS "systemd not found; building without systemd support")
+  endif()
+
+  check_function_exists(epoll_pwait2 HAVE_EPOLL_PWAIT2)
 endif()
 
 file(MAKE_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}/src/")
 
 add_subdirectory(doc)
 add_subdirectory(src)
+if(EXISTS "${CMAKE_CURRENT_SOURCE_DIR}/test")
+  add_subdirectory(test)
+else()
+  message(STATUS "Test directory not found, skipping tests")
+endif()

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -19,23 +19,37 @@
   #
   include_directories(
     ${CMAKE_CURRENT_SOURCE_DIR}/include
-    ${LIBEV_INCLUDE_DIRS}
     ${OPENSSL_INCLUDE_DIR}
-    ${SYSTEMD_INCLUDE_DIRS}
-    ${CJSON_INCLUDE_DIRS}
+    ${THREAD_INCLUDE_DIRS}
+    ${ZLIB_INCLUDE_DIRS}
+    ${BZIP2_INCLUDE_DIRS}
+    ${ZSTD_INCLUDE_DIRS}
+    ${LZ4_INCLUDE_DIRS}
   )
 
   #
   # Library directories
   #
   link_libraries(
-    ${LIBEV_LIBRARIES}
     ${OPENSSL_CRYPTO_LIBRARY}
     ${OPENSSL_SSL_LIBRARY}
-    ${SYSTEMD_LIBRARIES}
     ${LIBATOMIC_LIBRARY}
-    ${CJSON_LIBRARIES}
-  )
+    ${THREAD_LIBRARY}
+    ${ZLIB_LIBRARIES}
+    ${BZIP2_LIBRARIES}
+    ${ZSTD_LIBRARIES}
+    ${LZ4_LIBRARIES}
+  )
+
+  #
+  # Event library backend
+  #
+  if (NOT LIBURING_FOUND)
+    message(FATAL_ERROR "liburing was not found")
+  endif()
+
+  include_directories(${LIBURING_INCLUDE_DIRS})
+  link_libraries(${LIBURING_LIBRARY})
 
   set(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -Wl,--no-undefined")
 elseif(${CMAKE_SYSTEM_NAME} STREQUAL "Darwin")
@@ -69,18 +83,24 @@
   #
   include_directories(
     ${CMAKE_CURRENT_SOURCE_DIR}/include
-    ${LIBEV_INCLUDE_DIRS}
     ${OPENSSL_INCLUDE_DIRS}
-    ${CJSON_INCLUDE_DIRS}
+    ${THREAD_INCLUDE_DIRS}
+    ${ZLIB_INCLUDE_DIRS}
+    ${BZIP2_INCLUDE_DIRS}
+    ${ZSTD_INCLUDE_DIRS}
+    ${LZ4_INCLUDE_DIRS}
   )
 
   #
   # Library directories
   #
   link_libraries(
-    ${LIBEV_LIBRARIES}
     ${OPENSSL_LIBRARIES}
-    ${CJSON_LIBRARIES}
+    ${THREAD_LIBRARY}
+    ${ZLIB_LIBRARIES}
+    ${BZIP2_LIBRARIES}
+    ${ZSTD_LIBRARIES}
+    ${LZ4_LIBRARIES}
   )
 else()
 
@@ -95,23 +115,36 @@
      add_compile_options(-DHAVE_FREEBSD)
   endif()
 
+  if (SYSTEMD_FOUND)
+  add_compile_options(-DHAVE_SYSTEMD)
+
+  include_directories(${SYSTEMD_INCLUDE_DIRS})
+  link_libraries(${SYSTEMD_LIBRARIES})
+  endif()
+
   #
   # Include directories
   #
   include_directories(
     ${CMAKE_CURRENT_SOURCE_DIR}/include
-    ${LIBEV_INCLUDE_DIRS}
     ${OPENSSL_INCLUDE_DIRS}
-    ${CJSON_INCLUDE_DIRS}
+    ${THREAD_INCLUDE_DIRS}
+    ${ZLIB_INCLUDE_DIRS}
+    ${BZIP2_INCLUDE_DIRS}
+    ${ZSTD_INCLUDE_DIRS}
+    ${LZ4_INCLUDE_DIRS}
   )
 
   #
   # Library directories
   #
   link_libraries(
-    ${LIBEV_LIBRARIES}
     ${OPENSSL_LIBRARIES}
-    ${CJSON_LIBRARIES}
+    ${THREAD_LIBRARY}
+    ${ZLIB_LIBRARIES}
+    ${BZIP2_LIBRARIES}
+    ${ZSTD_LIBRARIES}
+    ${LZ4_LIBRARIES}
   )
 endif()
 
@@ -144,6 +177,11 @@
   set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -fPIC")
 endif()
 
+check_include_file(execinfo.h HAVE_EXECINFO_H)
+if (HAVE_EXECINFO_H)
+  add_compile_options(-DHAVE_EXECINFO_H)
+endif()
+
 if (${CMAKE_SYSTEM_NAME} STREQUAL "Linux")
   include(CheckPIESupported)
   check_pie_supported()
@@ -198,11 +236,83 @@
   endif()
 
   if(CMAKE_C_COMPILER_ID STREQUAL "Clang")
+    add_compile_options(-fprofile-instr-generate)
+    add_compile_options(-fcoverage-mapping)
+    add_link_options(-fprofile-instr-generate)
     if (NOT ${CMAKE_SYSTEM_NAME} STREQUAL "OpenBSD")
-      add_compile_options(-fsanitize=address)
-
-      set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_LINKER_FLAGS_DEBUG} -fsanitize=address")
-      set(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS_DEBUG} -fsanitize=address")
+      if (NOT ${CMAKE_SYSTEM_PROCESSOR} STREQUAL "aarch64")
+        if (CMAKE_C_COMPILER_VERSION VERSION_GREATER_EQUAL 3.2)
+          add_compile_options(-fsanitize=address)
+          add_compile_options(-fno-sanitize=null)
+          
+          if (CMAKE_C_COMPILER_VERSION VERSION_GREATER_EQUAL 3.3)
+            add_compile_options(-fsanitize=undefined)
+            add_compile_options(-fsanitize=float-divide-by-zero)
+            add_compile_options(-fsanitize=float-cast-overflow)
+          endif()
+          
+          if (CMAKE_C_COMPILER_VERSION VERSION_GREATER_EQUAL 3.6)
+            add_compile_options(-fno-sanitize-recover=all)
+          endif()
+          
+          if (CMAKE_C_COMPILER_VERSION VERSION_GREATER_EQUAL 3.8)
+            add_compile_options(-fsanitize-recover=address)
+          endif()
+          
+          if (CMAKE_C_COMPILER_VERSION VERSION_GREATER_EQUAL 3.9)
+            add_compile_options(-fsanitize-address-use-after-scope)
+          endif()
+          
+          add_compile_options(-fno-sanitize=alignment)
+
+          set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_LINKER_FLAGS_DEBUG} -fsanitize=address -fsanitize=undefined -fno-sanitize-recover=all -fsanitize=float-divide-by-zero -fsanitize=float-cast-overflow -fno-sanitize=null -fno-sanitize=alignment")
+          set(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS_DEBUG} -fsanitize=address -fsanitize=undefined -fno-sanitize-recover=all -fsanitize=float-divide-by-zero -fsanitize=float-cast-overflow -fno-sanitize=null -fno-sanitize=alignment")        
+        endif()
+      endif()
+    endif()
+  elseif(CMAKE_C_COMPILER_ID STREQUAL "GNU")
+    add_compile_options(--coverage -O0 -g)
+    add_link_options(--coverage)
+    if (NOT ${CMAKE_SYSTEM_NAME} STREQUAL "OpenBSD")
+      if (NOT ${CMAKE_SYSTEM_PROCESSOR} STREQUAL "aarch64")
+        if (CMAKE_C_COMPILER_VERSION VERSION_GREATER_EQUAL 4.8)
+          add_compile_options(-fsanitize=address)
+          
+          set(TEMP_EXE_LINKER_FLAGS "-fsanitize=address")
+          set(TEMP_SHARED_LINKER_FLAGS "-fsanitize=address")
+          
+          if (CMAKE_C_COMPILER_VERSION VERSION_GREATER_EQUAL 4.9)
+            add_compile_options(-fsanitize=undefined)
+            set(TEMP_EXE_LINKER_FLAGS "${TEMP_EXE_LINKER_FLAGS} -fsanitize=undefined")
+            set(TEMP_SHARED_LINKER_FLAGS "${TEMP_SHARED_LINKER_FLAGS} -fsanitize=undefined")
+          endif()
+          
+          if (CMAKE_C_COMPILER_VERSION VERSION_GREATER_EQUAL 5.1)
+            add_compile_options(-fno-sanitize=alignment)
+            add_compile_options(-fno-sanitize-recover=all)
+            add_compile_options(-fsanitize=float-cast-overflow)
+            add_compile_options(-fsanitize=float-divide-by-zero)
+            
+            set(TEMP_EXE_LINKER_FLAGS "${TEMP_EXE_LINKER_FLAGS} -fno-sanitize=alignment -fno-sanitize-recover=all -fsanitize=float-cast-overflow -fsanitize=float-divide-by-zero")
+            set(TEMP_SHARED_LINKER_FLAGS "${TEMP_SHARED_LINKER_FLAGS} -fno-sanitize=alignment -fno-sanitize-recover=all -fsanitize=float-cast-overflow -fsanitize=float-divide-by-zero")
+          endif()
+          
+          if (CMAKE_C_COMPILER_VERSION VERSION_GREATER_EQUAL 6.0)
+            add_compile_options(-fsanitize-recover=address)
+            set(TEMP_EXE_LINKER_FLAGS "${TEMP_EXE_LINKER_FLAGS} -fsanitize-recover=address")
+            set(TEMP_SHARED_LINKER_FLAGS "${TEMP_SHARED_LINKER_FLAGS} -fsanitize-recover=address")
+          endif()
+          
+          if (CMAKE_C_COMPILER_VERSION VERSION_GREATER_EQUAL 7.0)
+            add_compile_options(-fsanitize-address-use-after-scope)
+            set(TEMP_EXE_LINKER_FLAGS "${TEMP_EXE_LINKER_FLAGS} -fsanitize-address-use-after-scope")
+            set(TEMP_SHARED_LINKER_FLAGS "${TEMP_SHARED_LINKER_FLAGS} -fsanitize-address-use-after-scope")
+          endif()
+          
+          set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} ${TEMP_EXE_LINKER_FLAGS}")
+          set(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} ${TEMP_SHARED_LINKER_FLAGS}")
+        endif()
+      endif()
     endif()
   endif()
 
@@ -210,6 +320,20 @@
   if (HAS_NO_OMIT_FRAME_POINTER)
     set(CMAKE_C_FLAGS_DEBUG "${CMAKE_C_FLAGS_DEBUG} -fno-omit-frame-pointer")
   endif()
+  
+  check_c_compiler_flag(-Wextra HAS_WEXTRA)
+  if (HAS_WEXTRA)
+    if (NOT ${CMAKE_SYSTEM_NAME} STREQUAL "Darwin" AND NOT ${CMAKE_SYSTEM_NAME} STREQUAL "FreeBSD")
+      add_compile_options(-Wextra)
+      
+      check_c_compiler_flag(-Wno-sign-compare HAS_NO_SIGN_COMPARE)
+      if (HAS_NO_SIGN_COMPARE)
+        add_compile_options(-Wno-sign-compare)
+      endif()
+    endif()
+  endif()
+
+  set(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS_DEBUG} -g")
 endif()
 
 if (CMAKE_BUILD_TYPE MATCHES Release OR CMAKE_BUILD_TYPE MATCHES RelWithDebInfo)
@@ -239,85 +363,3 @@
 
   check_c_compiler_flag(-fstack-protector-strong HAS_STACKPROTECTOR_STRONG)
   if (HAS_STACKPROTECTOR_STRONG)
-    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -fstack-protector-strong")
-  else()
-    check_c_compiler_flag(-fstack-protector HAS_STACKPROTECTOR)
-    if (HAS_STACKPROTECTOR)
-      set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -fstack-protector")
-    endif()
-  endif()
-
-  check_c_compiler_flag(-Wl,arg HAS_LINKER)
-  check_linker_flag(C "-z relro" LINKER_HAS_RELRO)
-  if (HAS_LINKER AND HAS_RELRO)
-    set (CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -Wl,-z,relro")
-    set (CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -Wl,-z,relro")
-  endif()
-
-  check_linker_flag(C "-z now" LINKER_HAS_NOW)
-  if (HAS_LINKER AND LINKER_HAS_NOW)
-    set (CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -Wl,-z,now")
-    set (CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -Wl,-z,now")
-  endif()
-endif (CMAKE_BUILD_TYPE MATCHES Release OR CMAKE_BUILD_TYPE MATCHES RelWithDebInfo)
-
-if (CMAKE_BUILD_TYPE MATCHES Performance)
-  add_compile_options(-O2)
-  add_compile_options(-DNDEBUG)
-
-  if(CMAKE_C_COMPILER_ID STREQUAL "GNU")
-    add_compile_options(-march=native)
-    add_compile_options(-mtune=native)
-    add_compile_options(-flto)
-  endif()
-endif (CMAKE_BUILD_TYPE MATCHES Performance)
-
-#
-# Build libpgagroal
-#
-add_library(pgagroal SHARED ${SOURCES})
-set_target_properties(pgagroal PROPERTIES LINKER_LANGUAGE C VERSION ${VERSION_STRING}
-                               SOVERSION ${VERSION_MAJOR})
-target_link_libraries(pgagroal PUBLIC)
-
-install(TARGETS pgagroal DESTINATION ${CMAKE_INSTALL_LIBDIR}/)
-
-#
-# Build pgagroal
-#
-add_executable(pgagroal-bin main.c ${RESOURCE_OBJECT})
-if (CMAKE_C_LINK_PIE_SUPPORTED)
-  set_target_properties(pgagroal-bin PROPERTIES LINKER_LANGUAGE C POSITION_INDEPENDENT_CODE TRUE OUTPUT_NAME pgagroal)
-else()
-  set_target_properties(pgagroal-bin PROPERTIES LINKER_LANGUAGE C POSITION_INDEPENDENT_CODE FALSE OUTPUT_NAME pgagroal)
-endif()
-target_link_libraries(pgagroal-bin pgagroal)
-
-install(TARGETS pgagroal-bin DESTINATION ${CMAKE_INSTALL_BINDIR})
-
-#
-# Build pgagroal-cli
-#
-add_executable(pgagroal-cli-bin cli.c ${RESOURCE_OBJECT})
-if (CMAKE_C_LINK_PIE_SUPPORTED)
-  set_target_properties(pgagroal-cli-bin PROPERTIES LINKER_LANGUAGE C POSITION_INDEPENDENT_CODE TRUE OUTPUT_NAME pgagroal-cli)
-else()
-  set_target_properties(pgagroal-cli-bin PROPERTIES LINKER_LANGUAGE C POSITION_INDEPENDENT_CODE FALSE OUTPUT_NAME pgagroal-cli)
-endif()
-target_link_libraries(pgagroal-cli-bin pgagroal)
-
-install(TARGETS pgagroal-cli-bin DESTINATION ${CMAKE_INSTALL_BINDIR})
-
-#
-# Build pgagroal-admin
-#
-add_executable(pgagroal-admin-bin admin.c ${RESOURCE_OBJECT})
-if (CMAKE_C_LINK_PIE_SUPPORTED)
-  set_target_properties(pgagroal-admin-bin PROPERTIES LINKER_LANGUAGE C POSITION_INDEPENDENT_CODE TRUE OUTPUT_NAME pgagroal-admin)
-else()
-  set_target_properties(pgagroal-admin-bin PROPERTIES LINKER_LANGUAGE C POSITION_INDEPENDENT_CODE FALSE OUTPUT_NAME pgagroal-admin)
-endif()
-target_link_libraries(pgagroal-admin-bin pgagroal)
-
-install(TARGETS pgagroal-admin-bin DESTINATION ${CMAKE_INSTALL_BINDIR})
-

=== debian/changelog ===
pgagroal (2.0.0-1) experimental; urgency=medium

  * New upstream version 2.0.0.
  * Drop big-endian patch, rejected upstream.
  * Upload to experimental to check architecture portability.

 -- Christoph Berg <myon@debian.org>  Thu, 29 Jan 2026 13:57:59 +0100

=== debian/control ===
--- 
+++ 
@@ -7,13 +7,18 @@
 Build-Depends:
  cmake (>= 3.14.0),
  debhelper-compat (= 13),
+ libbz2-dev,
  libcjson-dev,
  libev-dev,
+ liblz4-dev,
  libssl-dev,
  libsystemd-dev,
+ liburing-dev,
+ libzstd-dev,
  postgresql-all,
  python3-docutils,
-Standards-Version: 4.6.1
+ zlib1g-dev,
+Standards-Version: 4.7.2
 Rules-Requires-Root: no
 Homepage: https://github.com/agroal/pgagroal
 Vcs-Browser: https://salsa.debian.org/postgresql/pgagroal
